#include "Connection.h"
#include "Config.h"

float amplitude = 1.0;

/*
 * Abonnements
 */
void subscribe()
{
  Connection::subscribe("amplitude");
}

/*
 * Réception des message MQTT
 */
void handleMessage(char *inTopic, byte *inPayload, unsigned int inLength)
{
  /* termine la chaine */
  inPayload[inLength] = '\0';
  amplitude = atof((char *)inPayload);
}

void setup() {
  /* Pour le debug */
  DSB(115200);
  /* 
   * Connexion 
   * ssid = nom du réseau WiFi
   * pass = mot de passe du réseau WiFi
   * "Sinus" = nom de l'ESP sur le réseau (.local) et sur le Broker
   * broker = nom du Broker (.local)
   * OTAPass = mot de passe pour le téléversement du logiciel via l'OTA
   */
  Connection::setup(ssid, pass, "Sinus", broker, OTAPass);
  Connection::attach(subscribe, handleMessage);
}

void loop() {
  static uint32_t dateDePublication = 0;

  uint32_t dateCourante = millis();
  if (dateCourante - dateDePublication > 200) {
    Connection::publish(
      "sinus",
      amplitude * sin ( 2 * PI * (float) dateCourante / 10000.0)
    );
    dateDePublication = dateCourante;
  }
  
  Connection::loop();  
}
